﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PizzaShopDesignPatterns
{
    class PizzaMan : IObserver
    {
        public IPizzaFactory PizzaFactory { get; set; }
        public PizzaOven PizzaOven { get; set; }
        public IPriceStrategy EveningPriceStrategy = new EveningPriceStrategy();
        public IPriceStrategy LunchPriceStrategy = new LunchPriceStrategy();
        public IPriceStrategy NightPriceStrategy = new NightPriceStrategy();
        public enum TimeOfDay
        {
            Lunch,
            Evening,
            Night
        };

        public TimeOfDay DayTime { get; set; }

        public PizzaMan(PizzaOven pizzaOven)
        {
            PizzaFactory = new PizzaFactory();
            DayTime = TimeOfDay.Evening;
            this.PizzaOven = pizzaOven;
            pizzaOven.AddObserver(this);
        }

        public void TakeOrder(String[] additionals)
        {
            AbstractPizza pizza = PizzaFactory.MakePizza(additionals);
            PizzaOven.preparePizza(new PizzaToMenuAdapter(pizza, null, 0));

        }

        public void TakeOrder(string[] additionals, string drink, double price)
        {
            AbstractPizza pizza = PizzaFactory.MakePizza(additionals);
            PizzaOven.preparePizza(new PizzaToMenuAdapter(pizza, drink, price));
        }
        public void Notify(IMenu pizza)
        {
            double price = 0;
            Console.WriteLine("ohhh a pizza is ready: " + pizza.Pizza);

            if (pizza.Drink != null)
                Console.WriteLine("Your menu with: " + pizza.Drink);
            switch (DayTime)
            {
                case TimeOfDay.Evening:
                    price = EveningPriceStrategy.CalculatePrice(pizza);
                    break;
                case TimeOfDay.Lunch:
                    price = LunchPriceStrategy.CalculatePrice(pizza);
                    break;
                case TimeOfDay.Night:
                    price = NightPriceStrategy.CalculatePrice(pizza); break;
            }
            Console.WriteLine("" + price + " kr. Please");
            Console.WriteLine();
        }
    }


}
