﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.ConstrainedExecution;
using System.Text;
using System.Threading.Tasks;

namespace PizzaShopDesignPatterns
{
    public class PizzaOven : IObservable
    {
        Random random = new Random();

        private List<IObserver> _observers = new List<IObserver>(); 

     
        private void NotifyObservers(IMenu pizza)
        {
            foreach (var observer in _observers)
            {
                observer.Notify(pizza);
            }
        }

        public void AddObserver(IObserver observer)
        {
           _observers.Add(observer); 
        }

        public void preparePizza(IMenu p)
        {
                       
            Task.Factory.StartNew(() =>
            {
                int preparetime = random.Next(5, 15);
                System.Threading.Thread.Sleep(preparetime*100);  
                NotifyObservers(p);
            }); 
        }

        
    }
}
